public class Triple {
   
   double x,y,z;

   //I added this to make it easy to duplicate the data structure
   //really should implement the Clonable interface...
    Triple(Triple t) {
        this.x=t.x;
        this.y=t.y;
        this.z=t.z;
    }
    
   Triple(double x, double y, double z) {
      this.x=x;
      this.y=y;
      this.z=z;
   }

   Triple(double[] a) {
      x=a[1];
      y=a[2];
      z=a[3];
   }

   Triple() {
      x=y=z=0;
   }

   public static Triple AddTriple(Triple a, Triple b) {
      Triple sum = new Triple();

      sum.x = a.x + b.x;
      sum.y = a.y + b.y;
      sum.z = a.z + b.z;

      return sum;

   }

   public static Triple SubTriple(Triple a, Triple b) {
      Triple diff = new Triple();

      diff.x = a.x - b.x;
      diff.y = a.y - b.y;
      diff.z = a.z - b.z;

      return diff;

   }

   public static Triple TripleDot(Triple a, Triple b) {
      Triple dot = new Triple();

      dot.x = a.x * b.x;
      dot.y = a.y * b.y;
      dot.z = a.z * b.z;

      return dot;

   }

   public static Triple TripleCross(Triple a, Triple b) {
      Triple cross = new Triple();

      cross.x = a.y * b.z - a.z * b.y;
      cross.y = a.x * b.z - a.z * b.x;
      cross.z = a.x * b.y - a.y * b.x;

      return cross;

   }

   public static Triple SMultTriple(double s, Triple a) {
      Triple smult = new Triple();

      smult.x = s*a.x;
      smult.y = s*a.y;
      smult.z = s*a.z;

      return smult;

   }

   public static Triple SDivTriple(Triple a, double s) {
      Triple sdiv = new Triple();

      sdiv.x = a.x/s;
      sdiv.y = a.y/s;
      sdiv.z = a.z/s;

      return sdiv;

   }

   public static double TripleMag(Triple a) {
      return Math.sqrt(a.x*a.x+a.y*a.y+a.z*a.z);
   }

//Added by Bob 10-25 rwv4@po.cwru.edu
   public float[] getFloats(float scale, double fx, double fy, double fz) {
	float[] holder = new float[3];
	holder[0]=(float)	((x+fx)*scale); 
	holder[1]=(float)	((y+fy)*scale); 
	holder[2]=(float)	((z+fz)*scale);
	return(holder);
   }
//End add
    public void copy(Triple t) {
        t.x=x;t.y=y;t.z=z;        
    }
}
